Index: /qPingTool/branches/plone-3.1/tests/__init__.py
===================================================================
--- /qPingTool/branches/plone-3.1/tests/__init__.py	(revision 201)
+++ /qPingTool/branches/plone-3.1/tests/__init__.py	(revision 202)
@@ -1,6 +1,0 @@
-"""\
-qPingTool tests package
-
-To run all tests type 'python runalltests.py'
-"""
-
Index: ingTool/branches/plone-3.1/tests/framework.py
===================================================================
--- /qPingTool/branches/plone-3.1/tests/framework.py	(revision 201)
+++ 	(revision )
@@ -1,106 +1,0 @@
-##############################################################################
-#
-# ZopeTestCase
-#
-# COPY THIS FILE TO YOUR 'tests' DIRECTORY.
-#
-# This version of framework.py will use the SOFTWARE_HOME
-# environment variable to locate Zope and the Testing package.
-#
-# If the tests are run in an INSTANCE_HOME installation of Zope,
-# Products.__path__ and sys.path with be adjusted to include the
-# instance's Products and lib/python directories respectively.
-#
-# If you explicitly set INSTANCE_HOME prior to running the tests,
-# auto-detection is disabled and the specified path will be used
-# instead.
-#
-# If the 'tests' directory contains a custom_zodb.py file, INSTANCE_HOME
-# will be adjusted to use it.
-#
-# If you set the ZEO_INSTANCE_HOME environment variable a ZEO setup
-# is assumed, and you can attach to a running ZEO server (via the
-# instance's custom_zodb.py).
-#
-##############################################################################
-#
-# The following code should be at the top of every test module:
-#
-# import os, sys
-# if __name__ == '__main__':
-#     execfile(os.path.join(sys.path[0], 'framework.py'))
-#
-# ...and the following at the bottom:
-#
-# if __name__ == '__main__':
-#     framework()
-#
-##############################################################################
-
-__version__ = '0.2.3'
-
-# Save start state
-#
-__SOFTWARE_HOME = os.environ.get('SOFTWARE_HOME', '')
-__INSTANCE_HOME = os.environ.get('INSTANCE_HOME', '')
-
-if __SOFTWARE_HOME.endswith(os.sep):
-    __SOFTWARE_HOME = os.path.dirname(__SOFTWARE_HOME)
-
-if __INSTANCE_HOME.endswith(os.sep):
-    __INSTANCE_HOME = os.path.dirname(__INSTANCE_HOME)
-
-# Find and import the Testing package
-#
-if not sys.modules.has_key('Testing'):
-    p0 = sys.path[0]
-    if p0 and __name__ == '__main__':
-        os.chdir(p0)
-        p0 = ''
-    s = __SOFTWARE_HOME
-    p = d = s and s or os.getcwd()
-    while d:
-        if os.path.isdir(os.path.join(p, 'Testing')):
-            zope_home = os.path.dirname(os.path.dirname(p))
-            sys.path[:1] = [p0, p, zope_home]
-            break
-        p, d = s and ('','') or os.path.split(p)
-    else:
-        print 'Unable to locate Testing package.',
-        print 'You might need to set SOFTWARE_HOME.'
-        sys.exit(1)
-
-import Testing, unittest
-execfile(os.path.join(os.path.dirname(Testing.__file__), 'common.py'))
-
-# Include ZopeTestCase support
-#
-if 1:   # Create a new scope
-
-    p = os.path.join(os.path.dirname(Testing.__file__), 'ZopeTestCase')
-
-    if not os.path.isdir(p):
-        print 'Unable to locate ZopeTestCase package.',
-        print 'You might need to install ZopeTestCase.'
-        sys.exit(1)
-
-    ztc_common = 'ztc_common.py'
-    ztc_common_global = os.path.join(p, ztc_common)
-
-    f = 0
-    if os.path.exists(ztc_common_global):
-        execfile(ztc_common_global)
-        f = 1
-    if os.path.exists(ztc_common):
-        execfile(ztc_common)
-        f = 1
-
-    if not f:
-        print 'Unable to locate %s.' % ztc_common
-        sys.exit(1)
-
-# Debug
-#
-print 'SOFTWARE_HOME: %s' % os.environ.get('SOFTWARE_HOME', 'Not set')
-print 'INSTANCE_HOME: %s' % os.environ.get('INSTANCE_HOME', 'Not set')
-sys.stdout.flush()
Index: ingTool/branches/plone-3.1/tests/runalltests.py
===================================================================
--- /qPingTool/branches/plone-3.1/tests/runalltests.py	(revision 201)
+++ 	(revision )
@@ -1,28 +1,0 @@
-#
-# Runs all tests in the current directory
-#
-# Execute like:
-#   python runalltests.py
-#
-# Alternatively use the testrunner:
-#   python /path/to/Zope/utilities/testrunner.py -qa
-#
-
-import os, sys
-if __name__ == '__main__':
-    execfile(os.path.join(sys.path[0], 'framework.py'))
-
-import unittest
-TestRunner = unittest.TextTestRunner
-suite = unittest.TestSuite()
-
-tests = os.listdir(os.curdir)
-tests = [n[:-3] for n in tests if n.startswith('test') and n.endswith('.py')]
-
-for test in tests:
-    m = __import__(test)
-    if hasattr(m, 'test_suite'):
-        suite.addTest(m.test_suite())
-
-if __name__ == '__main__':
-    TestRunner().run(suite)
Index: /qPingTool/branches/plone-3.1/tests/testPropertiesToolConf.py
===================================================================
--- /qPingTool/branches/plone-3.1/tests/testPropertiesToolConf.py	(revision 201)
+++ /qPingTool/branches/plone-3.1/tests/testPropertiesToolConf.py	(revision 202)
@@ -1,3 +1,2 @@
-
 from base import TestCase
 from config import nt_properties, s_properties
Index: /qPingTool/branches/plone-3.1/tests/testRegister.py
===================================================================
--- /qPingTool/branches/plone-3.1/tests/testRegister.py	(revision 201)
+++ /qPingTool/branches/plone-3.1/tests/testRegister.py	(revision 202)
@@ -2,8 +2,4 @@
 # Register skins
 #
-
-import os, sys
-if __name__ == '__main__':
-    execfile(os.path.join(sys.path[0], 'framework.py'))
 
 from base import *
@@ -28,5 +24,2 @@
     suite.addTest(makeSuite(TestSetup))
     return suite
-
-if __name__ == '__main__':
-    framework()
Index: /qPingTool/branches/plone-3.1/tests/testSkeleton.py
===================================================================
--- /qPingTool/branches/plone-3.1/tests/testSkeleton.py	(revision 201)
+++ /qPingTool/branches/plone-3.1/tests/testSkeleton.py	(revision 202)
@@ -2,8 +2,4 @@
 # qPingTool TestCase
 #
-
-import os, sys
-if __name__ == '__main__':
-    execfile(os.path.join(sys.path[0], 'framework.py'))
 
 from Testing import ZopeTestCase
@@ -21,5 +17,2 @@
     suite.addTest(makeSuite(TestSomething))
     return suite
-
-if __name__ == '__main__':
-    framework()
Index: /qPingTool/branches/plone-3.1/tests/test_pinginfo.py
===================================================================
--- /qPingTool/branches/plone-3.1/tests/test_pinginfo.py	(revision 201)
+++ /qPingTool/branches/plone-3.1/tests/test_pinginfo.py	(revision 202)
@@ -2,8 +2,4 @@
 # PingInfo TestCase
 #
-
-import os, sys
-if __name__ == '__main__':
-    execfile(os.path.join(sys.path[0], 'framework.py'))
 
 from base import *
@@ -33,6 +29,2 @@
     suite.addTest(makeSuite(TestPingInfo))
     return suite
-
-if __name__ == '__main__':
-    framework()
-
Index: /qPingTool/branches/plone-3.1/tests/test_pingtool.py
===================================================================
--- /qPingTool/branches/plone-3.1/tests/test_pingtool.py	(revision 201)
+++ /qPingTool/branches/plone-3.1/tests/test_pingtool.py	(revision 202)
@@ -2,8 +2,4 @@
 # PingTool TestCase
 #
-
-import os, sys
-if __name__ == '__main__':
-    execfile(os.path.join(sys.path[0], 'framework.py'))
 
 from base import *
@@ -65,5 +61,5 @@
         self.failUnless(status=='failed')
         self.failUnless(message=='Ping is dissabled.')
-"""
+
         # test with customized properties
         self.ptool.invokeFactory(id = 'testsite', type_name = "PingInfo", title = 'www.TESTSITE.com (blog url)', url = 'http://pingsite')
@@ -73,9 +69,5 @@
         self.failUnless(message=='Ping is impossible.Setup canonical_url.')
 
-        # test with customized properties
-        status, message = self.ptool.pingFeedReader(obj)
-        self.failUnless(status=='success')
-        self.failUnless(message=='The servers are pinged.\nReturned message from http://pingsite: The site http://pingsite generated error for plone/b1.')
-"""
+
 def test_suite():
     from unittest import TestSuite, makeSuite
@@ -83,6 +75,2 @@
     suite.addTest(makeSuite(TestPingTool))
     return suite
-
-if __name__ == '__main__':
-    framework()
-