Index: quintagroup.transmogrifier.pfm2pfg/trunk/quintagroup/transmogrifier/pfm2pfg/tests/fieldset_form.xml
===================================================================
--- quintagroup.transmogrifier.pfm2pfg/trunk/quintagroup/transmogrifier/pfm2pfg/tests/fieldset_form.xml	(revision 329)
+++ quintagroup.transmogrifier.pfm2pfg/trunk/quintagroup/transmogrifier/pfm2pfg/tests/fieldset_form.xml	(revision 334)
@@ -1,119 +1,4 @@
 <?xml version="1.0" encoding="utf-8"?>
 <metadata xmlns="http://plone.org/ns/archetypes/" xmlns:cmf="http://cmf.zope.org/namespaces/default/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:xmp="adobe:ns:meta">
-    <dc:title>
-        Form with fieldsets
-    </dc:title>
-    <xmp:CreateDate>
-        2007-05-15T08:41:51Z
-    </xmp:CreateDate>
-    <xmp:ModifyDate>
-        2007-12-04T09:25:47Z
-    </xmp:ModifyDate>
-    <field name="id">
-        fieldset-form
-    </field>
-    <field name="allowDiscussion">
-        None
-    </field>
-    <field name="effectiveDate">
-        2007/12/04 03:25:47.294 US/Central
-    </field>
-    <field name="recipient_email">
-        string:test@mail.com
-    </field>
-    <field name="body_pt">
-        &lt;tal:block i18n:domain=&quot;pfm&quot;
-        tal:define=&quot;form here/form;
-        groups form/get_groups;&quot;&gt;
-        &lt;html&gt;
-        &lt;body style=&quot;font-family:verdana,sans-serif;&quot;&gt;
-        &lt;p tal:condition=&quot;here/getBodyPre&quot; tal:content=&quot;here/getBodyPre&quot; /&gt;
-        &lt;p tal:condition=&quot;options/prepend&quot; tal:content=&quot;options/prepend&quot; /&gt;
-        
-        &lt;tal:block tal:repeat=&quot;group groups&quot;&gt;
-        &lt;h1 tal:condition=&quot;python:group!='Default'&quot; tal:content=&quot;group&quot; /&gt;
-        &lt;table style=&quot;font-family:verdana,sans-serif;&quot;&gt;
-        &lt;tbody valign=&quot;top&quot;&gt;
-        &lt;tal:block tal:repeat=&quot;field python:form.get_fields_in_group(group)&quot;&gt;
-        &lt;tr&gt;
-        &lt;th i18n:translate=&quot;&quot; style=&quot;text-align:right; white-space: nowrap; border-bottom: 1px solid #cccccc;&quot; tal:content=&quot;field/title&quot; /&gt;
-        &lt;td&gt;
-        &lt;div tal:repeat=&quot;line field/mailsplitter&quot;&gt;
-        &lt;span tal:content=&quot;line&quot;/&gt;
-        &lt;/div&gt;
-        &lt;/td&gt;
-        &lt;/tr&gt;
-        &lt;/tal:block&gt;
-        &lt;/tbody&gt;
-        &lt;/table&gt;
-        &lt;/tal:block&gt;
-        
-        &lt;p tal:condition=&quot;options/append&quot; tal:content=&quot;options/append&quot; /&gt;
-        &lt;p tal:condition=&quot;here/getBodyPost&quot; tal:content=&quot;here/getBodyPost&quot; /&gt;
-        &lt;pre tal:content=&quot;here/getFooter&quot; /&gt;
-        &lt;/body&gt;
-        &lt;/html&gt;
-        &lt;/tal:block&gt;
-    </field>
-    <field name="body_type">
-        text/html
-    </field>
-    <field name="form_pre">
-        
-        &lt;p&gt;form prologue&lt;/p&gt;
-        
-    </field>
-    <field name="form_post">
-        
-        &lt;p&gt;form epilogue&lt;/p&gt;
-        
-    </field>
-    <field name="form_buttons">
-        Submit|submit|submit|context
-    </field>
-    <field name="form_buttons">
-        Reset|reset|reset|standalone
-    </field>
-    <field name="sent_title">
-        The form was send to editor.
-    </field>
-    <field name="sent_message">
-        
-        &lt;p&gt;Thank you for new content. Our editor will review your request.&lt;br /&gt;&lt;/p&gt;
-        
-    </field>
-    <uid>
-        738f9995ffd82394ff8a3fb7c3545450
-    </uid>
-    <cmf:type>
-        PloneFormMailer
-    </cmf:type>
-    <cmf:workflow_history>
-        <cmf:workflow id="PloneFormMailer_workflow">
-            <cmf:history>
-                <cmf:var id="action" type="None" value="None"/>
-                <cmf:var id="actor" type="str" value="admin"/>
-                <cmf:var id="comments" type="str" value=""/>
-                <cmf:var id="review_state" type="str" value="members only send"/>
-                <cmf:var id="time" type="date" value="2007-05-15 03:41:51"/>
-            </cmf:history>
-            <cmf:history>
-                <cmf:var id="action" type="str" value="enable anonymous send"/>
-                <cmf:var id="actor" type="str" value="admin"/>
-                <cmf:var id="comments" type="str" value=""/>
-                <cmf:var id="review_state" type="str" value="anoymous send"/>
-                <cmf:var id="time" type="date" value="2007-12-04 03:25:47"/>
-            </cmf:history>
-        </cmf:workflow>
-    </cmf:workflow_history>
-    <cmf:security>
-        <cmf:local_role role="Owner" user_id="admin"/>
-    </cmf:security>
-    <field name="recipient_name">
-        ContentManagementSoftware.Info
-    </field>
-    <field name="subject">
-        string:Update Software
-    </field>
 <form>
   <title>PFM Formulator</title>