Index: /quintagroup.transmogrifier/branches/plone-2.1/quintagroup.transmogrifier/quintagroup/transmogrifier/exportimport.py
===================================================================
--- /quintagroup.transmogrifier/branches/plone-2.1/quintagroup.transmogrifier/quintagroup/transmogrifier/exportimport.py	(revision 344)
+++ /quintagroup.transmogrifier/branches/plone-2.1/quintagroup.transmogrifier/quintagroup/transmogrifier/exportimport.py	(revision 345)
@@ -5,5 +5,4 @@
 
 from Products.GenericSetup import context as gscontext
-#from Products.GenericSetup.interfaces import IFilesystemImporter
 
 from quintagroup.transmogrifier.writer import WriterSection
@@ -47,6 +46,9 @@
     # this function is also called when adding Plone site, so call standard handler
     if not context.readDataFile('.objects.xml', subdir='structure'):
-        from Products.GenericSetup.interfaces import IFilesystemImporter
-        IFilesystemImporter(context.getSite()).import_(context, 'structure', True)
+        try:
+            from Products.GenericSetup.interfaces import IFilesystemImporter
+            IFilesystemImporter(context.getSite()).import_(context, 'structure', True)
+        except ImportError:
+            pass
         return
 
@@ -80,24 +82,2 @@
     for item in pipeline:
         pass # discard once processed
-
-
-#class PloneSiteImporter(object):
-    #""" Importer of plone site.
-    #"""
-    #implements(IFilesystemImporter)
-
-    #def __init__(self, context):
-        #self.context = context
-
-    #def import_(self, import_context, subdir="structure", root=False):
-        ## When performing import steps we need to use standart importing adapter,
-        ## if 'object.xml' file is absent in 'structure' directory of the profile.
-        ## This may be because it is the base plone profile or extension profile, that has
-        ## structure part in other format.
-
-        #objects_xml = import_context.readDataFile('.objects.xml', subdir)
-        #if objects_xml is not None:
-            #importSiteStructure(import_context)
-        #else:
-            #from Products.CMFCore.exportimport.content import StructureFolderWalkingAdapter
-            #StructureFolderWalkingAdapter(self.context).import_(import_context, "structure", True)
Index: /quintagroup.transmogrifier/branches/plone-2.1/quintagroup.transmogrifier/quintagroup/transmogrifier/patches.py
===================================================================
--- /quintagroup.transmogrifier/branches/plone-2.1/quintagroup.transmogrifier/quintagroup/transmogrifier/patches.py	(revision 344)
+++ /quintagroup.transmogrifier/branches/plone-2.1/quintagroup.transmogrifier/quintagroup/transmogrifier/patches.py	(revision 345)
@@ -14,5 +14,5 @@
         profile_registry.registerProfile("default",
                                          "Transmogrifier",
-                                         "Export the site's structure and content.",
+                                         "Export/import the site's structure and content.",
                                          profile_path,
                                          #"quintagroup.transmogrifier",
@@ -21,10 +21,5 @@
 
 # TarballExportContext don't write dirs in tarball and we need to fix this
-
-#security.declareProtected( ManagePortal, 'writeDataFile' )
 def writeDataFile( self, filename, text, content_type, subdir=None ):
-
-    """ See IExportContext.
-    """
     mod_time = time.time()
 
@@ -106,5 +101,5 @@
     TarballImportContext.listDirectory = listDirectory
 except ImportError:
-    # we don't have TarballImportContext
-    # do nothing
+    # we don't have TarballImportContext, because setup_tool don't support importing
+    # profiles from tarball
     pass
Index: /quintagroup.transmogrifier/branches/plone-2.1/quintagroup.transmogrifier/quintagroup/transmogrifier/profiles/default/export_steps.xml
===================================================================
--- /quintagroup.transmogrifier/branches/plone-2.1/quintagroup.transmogrifier/quintagroup/transmogrifier/profiles/default/export_steps.xml	(revision 344)
+++ /quintagroup.transmogrifier/branches/plone-2.1/quintagroup.transmogrifier/quintagroup/transmogrifier/profiles/default/export_steps.xml	(revision 345)
@@ -1,8 +1,8 @@
 <?xml version="1.0"?>
 <export-steps>
- <export-step id="content"
-              handler="quintagroup.transmogrifier.exportimport.exportSiteStructure"
-              title="Content">
-  Export the site's structure and content.
- </export-step>
+    <export-step id="content" version="20081029-01"
+        handler="quintagroup.transmogrifier.exportimport.exportSiteStructure"
+        title="Content">
+        Export the site's structure and content.
+    </export-step>
 </export-steps>
Index: /quintagroup.transmogrifier/branches/plone-2.1/quintagroup.transmogrifier/quintagroup/transmogrifier/profiles/default/import_steps.xml
===================================================================
--- /quintagroup.transmogrifier/branches/plone-2.1/quintagroup.transmogrifier/quintagroup/transmogrifier/profiles/default/import_steps.xml	(revision 345)
+++ /quintagroup.transmogrifier/branches/plone-2.1/quintagroup.transmogrifier/quintagroup/transmogrifier/profiles/default/import_steps.xml	(revision 345)
@@ -0,0 +1,8 @@
+<?xml version="1.0"?>
+<import-steps>
+    <import-step id="content" version="20081029-01"
+        handler="quintagroup.transmogrifier.exportimport.importSiteStructure"
+        title="Content">
+        Import the site's structure and content.
+    </import-step>
+</import-steps>