Index: qPloneTabs/branches/quintagroup.plonetabs/trunk/quintagroup/plonetabs/browser/templates/actionslist.pt
===================================================================
--- qPloneTabs/branches/quintagroup.plonetabs/trunk/quintagroup/plonetabs/browser/templates/actionslist.pt	(revision 182)
+++ qPloneTabs/branches/quintagroup.plonetabs/trunk/quintagroup/plonetabs/browser/templates/actionslist.pt	(revision 348)
@@ -45,10 +45,11 @@
                       tab_title tab/title"
           tal:attributes="class python:test(error, '%s error' % attrs['class'], attrs['class'])">
-        <dt><label>Name</label></dt>
+        <dt><label tal:attributes="for name">Name</label></dt>
         <dd>
           <span class="error-container" tal:content="error">Validation error output</span>
           <input type="text" value="" name="title"
                  tal:attributes="value python:test(request.get(name, []) != [], request.get(name), tab_title);
-                                 name name" /></dd>
+                                 name name;
+                                 id name" /></dd>
       </dl>
 
@@ -61,10 +62,11 @@
                           tab_url tab/url_expr"
               tal:attributes="class python:test(error, '%s error' % attrs['class'], attrs['class'])">
-            <dt><label>URL (Expression)</label></dt>
+            <dt><label tal:attributes="for name">URL (Expression)</label></dt>
             <dd>
               <span class="error-container" tal:content="error">Validation error output</span>
               <input type="text" value="" name="url_expr"     size="30"
                      tal:attributes="value python:test(request.get(name, []) != [], request.get(name), tab_url);
-                                     name name" /></dd>
+                                     name name;
+                                     id name" /></dd>
           </dl>
           <dl class="edit-field-id"
@@ -73,10 +75,11 @@
                           tab_id tab/id"
               tal:attributes="class python:test(error, '%s error' % attrs['class'], attrs['class'])">
-            <dt><label>Id</label></dt>
+            <dt><label tal:attributes="for name">Id</label></dt>
             <dd>
               <span class="error-container" tal:content="error">Validation error output</span>
               <input type="text" value="" name="id"
                      tal:attributes="value python:test(request.get(name, []) != [], request.get(name), tab_id);
-                                     name name" /></dd>
+                                     name name;
+                                     id name" /></dd>
           </dl>
           <dl class="edit-field-condition"
@@ -85,10 +88,11 @@
                           tab_cond tab/available_expr"
               tal:attributes="class python:test(error, '%s error' % attrs['class'], attrs['class'])">
-            <dt><label>Condition (Expression)</label></dt>
+            <dt><label tal:attributes="for name">Condition (Expression)</label></dt>
             <dd>
               <span class="error-container" tal:content="error">Validation error output</span>
               <input type="text" value="" name="available_expr"  size="30"
                      tal:attributes="value python:test(request.get(name, []) != [], request.get(name), tab_cond);
-                                     name name" /></dd>
+                                     name name;
+                                     id name" /></dd>
           </dl>
           <div class="visualClear"><!-- --></div>
Index: qPloneTabs/branches/quintagroup.plonetabs/trunk/quintagroup/plonetabs/browser/templates/plonetabs.pt
===================================================================
--- qPloneTabs/branches/quintagroup.plonetabs/trunk/quintagroup/plonetabs/browser/templates/plonetabs.pt	(revision 182)
+++ qPloneTabs/branches/quintagroup.plonetabs/trunk/quintagroup/plonetabs/browser/templates/plonetabs.pt	(revision 348)
@@ -77,5 +77,5 @@
     <dl class="field-visible bridge">
       <dt>
-        <label>Visible</label>
+        <label for="actvisible">Visible</label>
       </dt>
       <dd>
@@ -88,5 +88,5 @@
         tal:attributes="class python:test(error, '%s error' % attrs['class'], attrs['class'])">
       <dt>
-        <label>Name</label>
+        <label for="actname">Name</label>
       </dt>
       <dd>
@@ -100,5 +100,5 @@
         tal:attributes="class python:test(error, '%s error' % attrs['class'], attrs['class'])">
       <dt>
-        <label>URL (Expression)</label>
+        <label for="actaction">URL (Expression)</label>
       </dt>
       <dd>
@@ -115,5 +115,5 @@
             tal:attributes="class python:test(error, '%s error' % attrs['class'], attrs['class'])">
           <dt>
-            <label>Id</label>
+            <label for="actid">Id</label>
           </dt>
           <dd>
@@ -127,5 +127,5 @@
             tal:attributes="class python:test(error, '%s error' % attrs['class'], attrs['class'])">
           <dt>
-            <label>Condition (Expression)</label>
+            <label for="actcondition">Condition (Expression)</label>
           </dt>
           <dd>